% ======= ARTIFICIAL SURFACE
% function to create artificial ET patterns
%--------------------------------------------------------------------------

[z , PixelWidth , PSD] = artificial_surf(2,0.8,15552,432,720,0.0001);

minz = abs(min(min(z)));
z = (z + minz)/2;

z = flipud(z);

% Create figure
% figure1 = figure('units','normalized','outerposition',[0.01 0.01 0.98 0.98]);
figure1=figure;
colormap(jet);
% Create axes
axes1 = axes('Parent',figure1);
hold(axes1,'on');
% Create image
imagesc(z,'Parent',axes1,'CDataMapping','scaled');

% Uncomment the following line to preserve the X-limits of the axes
xlim(axes1,[0.5 432.5]);
% Uncomment the following line to preserve the Y-limits of the axes
ylim(axes1,[0.5 720.5]);
box(axes1,'on');
axis(axes1,'ij');
% Set the remaining axes properties
set(axes1,'Layer','top');
% Create colorbar
colorbar('peer',axes1);
title(colorbar,'ETrate [mm/d]');
set(gca,'XTick',[],'YTick',[],'FontSize', 15);