%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% CHOSE COORDINATES DISTRIBUTION
% 
% Author: Silvia Garbin
% Creation: february 2017
% Last update: march 2017
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% find coordinates setting the type of distribution (flagR, flagC).
% (1) UNIFORM distribution
% (2) linear INCREASING distribution
% (3) linear DECREASING distribution

function [i, j] = coord_distr(flagR, flagC, nrow, ncol, ncoord, t)

% FIND COORDINATE i

switch flagR
case 1
% extract the cumulated value of the distribution along x direction
    FcumR = rand(1);
    i = round(nrow*FcumR);

% i must be >0
    if i == 0
        i = 1;
    end
    
    if ncoord==1 && t==1
        fprintf('Uniform coord along x \n');
    end
        
case 2
% extract the cumulated value of the distribution along x direction
    FcumR = rand(1);
    i = max([ round(sqrt(nrow^2*FcumR))  1]);

% i must be >0
%     if i == 0
%         i = 1;
%     end   
    
    if ncoord==1 && t==1
        fprintf('Increasing coord along x \n');
    end
        
case 3
% extract the cumulated value of the distribution along x direction
    FcumR = rand(1);
    i = max([ round((2*nrow-sqrt(4*nrow^2*(1-FcumR)))/2)  1]);

% i must be >0
%     if i == 0
%         i = 1;
%     end     
    
    if ncoord==1 && t==1
        fprintf('Decreasing coord along x \n');
    end
    
    otherwise
    error ('WrongFlagR in coord_distr');
    
end

% FIND COORDINATE Y
switch flagC
case 1
% extract the cumulated value of the distribution along x direction
    FcumC = rand(1);
    j = max([  round(ncol*FcumC) 1]);

% j must be >0
%     if j == 0
%         j = 1;
%     end
    
    if ncoord==1 && t==1
        fprintf('Uniform coord along y \n');
    end
        
case 2
% extract the cumulated value of the distribution along x direction
    FcumC = rand(1);
    j = max([  round(sqrt(ncol^2*FcumC))  1]);

% j must be >0
%     if j == 0
%         j = 1;
%     end     
    
    if ncoord==1 && t==1
        fprintf('Increasing coord along y \n');
    end
        
case 3
% extract the cumulated value of the distribution along x direction
    FcumC = rand(1);
    j = max([  round((2*ncol-sqrt(4*ncol^2*(1-FcumC)))/2)  1 ]);

% j must be >0
%     if j == 0
%         j = 1;
%     end          
    
    if ncoord==1 && t==1
        fprintf('Decreasing coord along y \n');
    end
        
    otherwise
    error ('WrongFlagC in coord_distr');

end

% check values
% i = max([i 1]);
% j = max([j 1]);

% end of function
return