% -------------------------------------------------------------------------
% COUNT JUNCTION function
% Recursive function that is able to count the junctions (/new Source
% Function) ustream each pixel [nSLJP], calculates the number of flow
% path usptream each pixel [nFlowPath] and the min length upstream each
% junction upstream each pixel [SLJP].
% 
% This function works in alpha_geomorph.m
%--------------------------------------------------------------------------
% 
% Authors: Silvia Garbin
% Creation: july 2016
% Last update: 
% 
% -------------------------------------------------------------------------
function [nSLJP,nFlowPath,SLJP]=count_junctions(FLD,LU,SLJM,SLJP,i,j,nrows,ncols,nSLJP,nFlowPath)

k=0;
m=0;
tm=0;
tk=0;
nj=0;
ix=0;

% define n_directions
MAX_DRAINING_PIXEL_IN_JUNCTION=8;
N_DIR=64;
NE_DIR=128;
E_DIR=1;
SE_DIR=2;
S_DIR=4;
SO_DIR=8;
O_DIR=16;
NO_DIR=32;


ti=zeros(MAX_DRAINING_PIXEL_IN_JUNCTION,1);
tj=zeros(MAX_DRAINING_PIXEL_IN_JUNCTION,1);
sourcepxl=0;

k=i;
m=j;

if LU(k+1,m+1)>1
    
    while LU(k+1,m+1)>1 && SLJM(k+1,m+1)==0.0 && sourcepxl~=1  
%         display(['St entrando in ciclo while con i=', num2str(i),' e j=', num2str(j)])
%         display(['Inizio ciclo while - nFlowPath ', num2str(nFlowPath)])
            
            tm=m;
            tk=k;      
            
            if m>0
                if FLD(k+1,m-1+1)==E_DIR 
                    tk=k+0;
                    tm=m-1;
                    nFlowPath=nFlowPath+1;
                end
            end
            
            if k<nrows-1 && m>0
                if FLD(k+1+1,m-1+1)==NE_DIR && LU(k+1+1,m-1+1)>1
                    tk=k+1;
                    tm=m-1;
                    nFlowPath=nFlowPath+sqrt(2);
                end
            end
            
            if k<nrows-1
                if FLD(k+1+1,m+1)==N_DIR && LU(k+1+1,m+1)>1
                    tk=k+1;
                    tm=m+0;
                    nFlowPath=nFlowPath+1;
                end
            end
            
            if k<nrows-1 && m<ncols-1
                if FLD(k+1+1,m+1+1)==NO_DIR && LU(k+1+1,m+1+1)>1
                    tk=k+1;
                    tm=m+1;
                    nFlowPath=nFlowPath+sqrt(2);
                end
            end
            
            if m<ncols-1
                if FLD(k+1,m+1+1)==O_DIR && LU(k+1,m+1+1)>1
                    tk=k+0;
                    tm=m+1;
                    nFlowPath=nFlowPath+1;
                end
            end
            
            if k>0 && m<ncols-1
                if FLD(k-1+1,m+1+1)==SO_DIR && LU(k-1+1,m+1+1)>1
                    tk=k-1;
                    tm=m+1;
                    nFlowPath=nFlowPath+sqrt(2);
                end
                
            end
            
            if k>0
                if FLD(k-1+1,m+1)==S_DIR && LU(k-1+1,m+1)>1
                    tk=k-1;
                    tm=m+0;
                    nFlowPath=nFlowPath+1;
                end
            end
            
            if k>0 && m>0
                if FLD(k-1+1,m-1+1)==SE_DIR && LU(k-1+1,m-1+1)>1
                    tk=k-1;
                    tm=m-1;
                    nFlowPath=nFlowPath+sqrt(2);
                end
            end
            
            if m==tm && k==tk
                sourcepxl=1;
            else
                sourcepxl=0;
            end
            
            m=tm;
            k=tk;
            
%             display(['Fine ciclo while - nFlowPath ', num2str(nFlowPath)])
    end  %closing while loop
    
%     display(['End ciclo while - nFlowPath ', num2str(nFlowPath)])
    
    if SLJM(k+1,m+1)>0.0  %find a junction
              
        if LU(k+1,m+1)>1  %only channelized pixels
            nj=0;
            
            if m>0
                if FLD(k+1,m-1+1)==E_DIR && LU(k+1,m-1+1)>1
                    ti(nj+1)=k;
                    tj(nj+1)=m-1;
                    nj=nj+1;
                end
            end
            
            if k<nrows-1 && m>0
                if FLD(k+1+1,m-1+1)==NE_DIR && LU(k+1+1,m-1+1)>1
                    ti(nj+1)=k+1;
                    tj(nj+1)=m-1;
                    nj=nj+1;
                end
            end
            
            if k<nrows-1
                if FLD(k+1+1,m+1)==N_DIR && LU(k+1+1,m+1)>1
                    ti(nj+1)=k+1;
                    tj(nj+1)=m;
                    nj=nj+1;
                end
            end
            
            if k<nrows-1 && m<ncols-1
                if FLD(k+1+1,m+1+1)==NO_DIR && LU(k+1+1,m+1+1)>1
                    ti(nj+1)=k+1;
                    tj(nj+1)=m+1;
                    nj=nj+1;
                end
            end
            
            if m<ncols-1
                if FLD(k+1,m+1+1)==O_DIR && LU(k+1,m+1+1)>1
                    ti(nj+1)=k;
                    tj(nj+1)=m+1;
                    nj=nj+1;
                end
            end
            
            if k>0 && m<ncols-1
                if FLD(k-1+1,m+1+1)==SO_DIR && LU(k-1+1,m+1+1)>1
                    ti(nj+1)=k-1;
                    tj(nj+1)=m+1;
                    nj=nj+1;
                end
                
            end
            
            if k>0
                if FLD(k-1+1,m+1)==S_DIR && LU(k-1+1,m+1)>1
                    ti(nj+1)=k-1;
                    tj(nj+1)=m;
                    nj=nj+1;
                end
            end
            
            if k>0 && m>0
                if FLD(k-1+1,m-1+1)==SE_DIR && LU(k-1+1,m-1+1)>1
                    ti(nj+1)=k-1;
                    tj(nj+1)=m-1;
                    nj=nj+1;
                end
            end
            
        end  %closing if statement
        
        if nj>1 %a junction
            SLJP(nSLJP+1)=SLJM(k+1,m+1);
%             display(['St uscendo con SLJP=', num2str(SLJP)])
            
            nSLJP=nSLJP+1;
            
            for ix=0:nj-1
                
%                 display(['St entrando in count con ti=', num2str(ti(ix+1,1)),' , tj=', num2str(tj(ix+1,1)),' e nFlowPath ', num2str(nFlowPath)])

                [nSLJP,nFlowPath,SLJP]=count_junctions(FLD,LU,SLJM,SLJP,ti(ix+1,1),tj(ix+1,1),nrows,ncols,nSLJP,nFlowPath);
                
%                 display(['Sono uscito da count con ti ', num2str(ti(ix+1,1)),' , tj ', num2str(tj(ix+1,1)),' e nFlowPath ', num2str(nFlowPath)])
%                 display(['Sono uscito da count con nSLJP ', num2str(nSLJP)])

            end
        end
    end
end %closing if statement
          
            
        