%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FILL PITS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [OUTPUT] = fill_pits(nrow, ncol, DTM)

fprintf('FILL PITS... \n');

% initialize the output array
OUTPUT = DTM;

% initialize the counter of the corrections and of the iterations
corrk = 1;
ncorrold = 0;
ncorr = 0;
iter = 0;

% loop until no correction has been introduced in the last iteration
while corrk ~= 0
    
    iter = iter + 1;
    
% loop over matrix nodes
    for jr = 2:nrow-1
        for jc = 2:ncol-1
            if ~isnan(OUTPUT(jr,jc))
                surrounding = [ OUTPUT(jr-1,jc-1:jc+1) OUTPUT(jr,jc-1) OUTPUT(jr,jc+1) OUTPUT(jr+1,jc-1:jc+1) ];
                if nanmin(surrounding) >= OUTPUT(jr,jc)
%                    disp([jr jc OUTPUT(jr,jc) nanmin(surrounding) nanmin(surrounding)+0.5]);
                    OUTPUT(jr,jc) = nanmin(surrounding) + 1;%0.1*iter;
                    ncorr = ncorr + 1;
                end
            end
        end
    end
    
    corrk = abs(ncorr-ncorrold);
    ncorrold = ncorr;
    fprintf('iter %u : %u corrections %u \n', iter, ncorr, corrk);

    
end

% end of the function
return  