%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% HABITAT SUITABILITY
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [node] = find_HS(node,nnodes, func, pdf)

% initialize time
ti0 = cputime;

% loop over the nodes
for jn = 1:nnodes
    
% set the mean of the PDF (HS-Lout relation)
    switch func
% decreasing linear function
        case 1 
            mean_HS = -0.00055*node(jn).L2out+1;
% increasing linear function        
        case 2
            mean_HS = 0.00055*node(jn).L2out+0.1;
% other pdf
        otherwise
            error ('Wrong PDF in find_HS');
    end
    
% set the habitat suitability for each node
    switch pdf
        case 1 
% exponential pdf
%         HS = max([ 1/10*floor( -log(1-rand(1))* mean_HS*10)   0.1]);
        HS = round(min ([ (-log(1-rand(1))* mean_HS)  1]),2);
        HS(HS==0) = 0.01;
        
        case 2
            
% other pdf

        otherwise
            error ('Wrong PDF in find_HS');
    end
    
% save the habitat suitability
    node(jn).HS = HS;

% end of loop
end

% end time
te = cputime;
% link_data(end) = [];
fprintf('habitat  : %10.3f s \n', te-ti0);

% end of function
return
