%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FIND BOUND OF A PIXELED AREA
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function boundary = find_bound(area)

% initialize the boundary matrix
boundary = nan(size(area));

% loop over the nodes
for i1 = 2:size(boundary,1)-1
    for i2 = 2:size(boundary,2)-1
        
        if ~isnan(area(i1,i2))

% check the surrounding nodes of the considered one, and if at least one
% is nan, then the considered node belongs to the bound
            jnan = sum(isnan(area(i1-1,i2-1:i2+1))); % row above
            jnan = jnan + sum(isnan(area(i1+1,i2-1:i2+1))); % row below
            jnan = jnan + sum(isnan(area(i1,i2-1:i2+1))); % same below
            
            if jnan>0
                boundary(i1,i2) = 1;
            end
        end

% end loop over nodes
    end       
end

% end of the function
return
