%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FIND THE COORDINATES OF THE RAIN CELL
% 
% Author: Silvia Garbin
% Creation: february 2017
% Last update: march 2017
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [event] = find_coord (flagR, flagC, nrow, ncol, nevents, t)

% initialize the matrix
    event = zeros(nevents,2);

% loop over the number of events per day (Nt(t))
for ncoord = 1:nevents
    
% find the coordinates of the centres
    [i, j] = coord_distr(flagR, flagC, nrow, ncol, ncoord, t);
    
% save the current centre
    event(ncoord,1) = i;
    event(ncoord,2) = j;
    
% check to avoid two events in the same position in the same day
    while find (ismember (event(1:ncoord-1,:),event(ncoord,:),'rows')) ==1
        
% find the new coordinates of the centres
        [inew, jnew] = coord_distr(flagR, flagC, nrow, ncol, ncoord);
        
% save the current new centre
        event(ncoord,1) = inew;
        event(ncoord,2) = jnew;
    
    end        
        
end
% end of function
return