%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FIND JUNCTION
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [Njunction, junction] = ...
    find_junction (flowdir,flowacc, nrow, ncol, threshold)

% initialize time
ti0 = cputime;


% define n_ flow directions

    MAX_DRAINING_PIXEL_IN_JUNCTION=8;

    N_DIR=64;
    NE_DIR=128;
    E_DIR=1;
    SE_DIR=2;
    S_DIR=4;
    SO_DIR=8;
    O_DIR=16;
    NO_DIR=32;

% initialize LU (lenght upstream) matrix 
    LU=zeros(nrow,ncol);

% Calculation of LU (lenght upstream) matrix using flow accumulation
% threshould. For equal contributing area, it takes the first one (correct)
% direction.
temp=0;
for i=0:nrow-1
    for j=0:ncol-1
        k=i;
        m=j;
        t=0;
        if flowacc(i+1,j+1)>threshold
            while flowacc(k+1,m+1)>threshold
            
            tm=m;
            tk=k;
            tt=t;
            
            if m>0
                if flowdir(k+1,m-1+1)==E_DIR
                    tk=k+0;
                    tm=m-1;
                    tt=t+1;
                    temp=flowacc(k+1,m-1+1);
                end
            end
            
            if k<nrow-1 && m>0
                if flowdir(k+1+1,m-1+1)==NE_DIR && flowacc(k+1+1,m-1+1)>temp
                    tk=k+1;
                    tm=m-1;
                    tt=t+sqrt(2);
                    temp=flowacc(k+1+1,m-1+1);
                end
            end
            
            if k<nrow-1
                if flowdir(k+1+1,m+1)==N_DIR && flowacc(k+1+1,m+1)>temp
                    tk=k+1;
                    tm=m+0;
                    tt=t+1;
                    temp=flowacc(k+1+1,m+1);
                end
            end
            
            if k<nrow-1 && m<ncol-1
                if flowdir(k+1+1,m+1+1)==NO_DIR && flowacc(k+1+1,m+1+1)>temp
                    tk=k+1;
                    tm=m+1;
                    tt=t+sqrt(2);
                    temp=flowacc(k+1+1,m+1+1);
                end
            end
            
            if m<ncol-1
                if flowdir(k+1,m+1+1)==O_DIR && flowacc(k+1,m+1+1)>temp
                    tk=k+0;
                    tm=m+1;
                    tt=t+1;
                    temp=flowacc(k+1,m+1+1);
                end
            end
            
            if k>0 && m<ncol-1
                if flowdir(k-1+1,m+1+1)==SO_DIR && flowacc(k-1+1,m+1+1)>temp
                    tk=k-1;
                    tm=m+1;
                    tt=t+sqrt(2);
                    temp=flowacc(k-1+1,m+1+1);
                end
                
            end
            
            if k>0
                if flowdir(k-1+1,m+1)==S_DIR && flowacc(k-1+1,m+1)>temp
                    tk=k-1;
                    tm=m+0;
                    tt=t+1;
                    temp=flowacc(k-1+1,m+1);
                end
            end
            
            if k>0 && m>0
                if flowdir(k-1+1,m-1+1)==SE_DIR && flowacc(k-1+1,m-1+1)>temp
                    tk=k-1;
                    tm=m-1;
                    tt=t+sqrt(2);
%                     temp=FLA(k-1+1,m-1+1);
                end
            end
            
            m=tm;
            k=tk;
            t=tt;
            temp=0;
            
            end %closing while loop
                
        end %closing if > threshold loop
                
        LU(i+1,j+1)=t;
        
    end %closing 2nd for loop
end %closing 1st for loop
clear i j 

% Calculation of n of junctions
z=0;
for i=0:nrow-1
    for j=0:ncol-1
        k=0;
        if LU(i+1,j+1)>1   %only channelized pixels
            
            if j>0
                if flowdir(i+1,j-1+1)==E_DIR && LU(i+1,j-1+1)>1
                    k=k+1;
                end
             end
            
            if i<nrow-1 && j>0
                if flowdir(i+1+1,j-1+1)==NE_DIR && LU(i+1+1,j-1+1)>1
                    k=k+1;
                end
            end
            
            if i<nrow-1
                if flowdir(i+1+1,j+1)==N_DIR && LU(i+1+1,j+1)>1
                    k=k+1;
                end
            end
            
            if i<nrow-1 && j<ncol-1
                if flowdir(i+1+1,j+1+1)==NO_DIR && LU(i+1+1,j+1+1)>1
                    k=k+1;
                end
            end
            
            if j<ncol-1
                if flowdir(i+1,j+1+1)==O_DIR && LU(i+1,j+1+1)>1
                    k=k+1;
                end
            end
            
            if i>0 && j<ncol-1
                if flowdir(i-1+1,j+1+1)==SO_DIR && LU(i-1+1,j+1+1)>1
                    k=k+1;
                end
            end
            
            if i>0
                if flowdir(i-1+1,j+1)==S_DIR && LU(i-1+1,j+1)>1
                    k=k+1;
                end
            end
            
            if i>0 && j>0
                if flowdir(i-1+1,j-1+1)==SE_DIR && LU(i-1+1,j-1+1)>1
                    k=k+1;
                end
            end
            
        end  %closing if channelized loop
        
        if k>1   % counter of joints
            z=z+1;   % n of junctions
        end 
    end  %closing 2nd for loop
end  %closing 1st for loop
% display(['N of junctions is: ', num2str(z)])
clear i j 

Njunction=z;

% Calculation of min lengths upstream of junctions matrix (SLJM) and vector
% (SLJ)
m=0;
% x=zeros(MAX_DRAINING_PIXEL_IN_JUNCTION,1);
SLJ=zeros(z+1,1);
% SLJ=zeros(MAX_DRAINING_PIXEL_IN_JUNCTION,1);
SLJM=zeros(nrow,ncol);  %junction min upstream length matrix:...
% 0 where NO junction, otherwise SLJ

for i=0:nrow-1
    for j=0:ncol-1
        k=0;
        x=zeros(MAX_DRAINING_PIXEL_IN_JUNCTION,1);
%         x(k+1)=0.0;
        
        if LU(i+1,j+1)>1   %only channelized pixels
            
            if j>0
                if flowdir(i+1,j-1+1)==E_DIR && LU(i+1,j-1+1)>1
                    x(k+1)=LU(i+1,j-1+1);
                    k=k+1;
                end
            end
            if i<nrow-1 && j>0
                if flowdir(i+1+1,j-1+1)==NE_DIR && LU(i+1+1,j-1+1)>1
                    x(k+1)=LU(i+1+1,j-1+1);
                    k=k+1;
                end
            end
            
            if i<nrow-1
                if flowdir(i+1+1,j+1)==N_DIR && LU(i+1+1,j+1)>1
                    x(k+1)=LU(i+1+1,j+1);
                    k=k+1;
                end
            end
            
            if i<nrow-1 && j<ncol-1
                if flowdir(i+1+1,j+1+1)==NO_DIR && LU(i+1+1,j+1+1)>1
                    x(k+1)=LU(i+1+1,j+1+1);
                    k=k+1;
                end
            end
            
            if j<ncol-1
                if flowdir(i+1,j+1+1)==O_DIR && LU(i+1,j+1+1)>1
                    x(k+1)=LU(i+1,j+1+1);
                    k=k+1;
                end
            end
            
            if i>0 && j<ncol-1
                if flowdir(i-1+1,j+1+1)==SO_DIR && LU(i-1+1,j+1+1)>1
                    x(k+1)=LU(i-1+1,j+1+1);
                    k=k+1;
                end
            end
            
            if i>0
                if flowdir(i-1+1,j+1)==S_DIR && LU(i-1+1,j+1)>1
                    x(k+1)=LU(i-1+1,j+1);
                    k=k+1;
                end
            end
            
            if i>0 && j>0
                if flowdir(i-1+1,j-1+1)==SE_DIR && LU(i-1+1,j-1+1)>1
                    x(k+1)=LU(i-1+1,j-1+1);
                    k=k+1;
                end
            end
            
        end  %closing if channelized loop
        
        if k>1   % counter of joints
                       
            x=sort(x,'descend');
            minx=x(2);
            
            SLJ(m+1)=minx;  %after identification of a junction the min ...
%             upstream length value is stored
            m=m+1;
            SLJM(i+1,j+1)=minx;
        end 
    end  %closing 2nd for loop
end  %closing 1st for loop
clear i j 

% initialize the array
junction = repmat(struct('i',0,'j',0,'k',0),Njunction, 1); 
kjunc = find (SLJM > 0);
[i,j] = ind2sub(size(flowdir),kjunc);
for jjunc = 1:Njunction
    junction(jjunc).i = i(jjunc);
    junction(jjunc).j = j(jjunc);
    junction(jjunc).k = kjunc(jjunc);
end

% end time
te = cputime;
fprintf('junctions  : %10.3f s \n', te-ti0);

% end of function
return




