%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FIND THE PARAMETER LAMBDA USING BUDYKO WATER BALANCE
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [fi, lambda] = find_lambdaBUDYKO(etc_dd, alphaP, lambdaP)

% initialize time
ti0 = cputime;

% calculate Budyko dryness index
Di = etc_dd/(alphaP*lambdaP);

% calculate the runoff coefficient fi
fi = 1-(Di*(1-exp(-Di))*tanh(1/Di))^0.5;

% calculate the parameter lambda
lambda = fi*lambdaP;

% fprintf(' %u  %8.2f   %8.2f    %8.2f   %8.2f    %8.5f    %8.2f   %8.2f   %8.2f  %8.2f   %8.2f \n',...
%     jn, w0, alphaP, lambdaP, Gamm, Eta, Par1, ga1, ga2, Ga, fi);

% end time
te = cputime;

% end of the function
return