%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FIND THE PARAMETER LAMBDA USING PORPORATO WATER BALANCE
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [fi, lambda,Di,Gamm,Ga] = find_lambdaPORPORATO(w0, etc_dd, lambdaP, meanrain)

% calculate Budyko dryness index
Di = etc_dd/meanrain;

% calculate Gamm factor
Gamm = w0*lambdaP/meanrain;

% calculate the incomplete gamma function
Ga = gamma(Gamm/Di)*gammainc(Gamm,Gamm/Di);

% calculate the runoff coefficient fi
fi = Di*Gamm^(Gamm/Di)*exp(-Gamm)/(Gamm*Ga);

%%
% calculate the parameter lambda
lambda = fi*lambdaP;

% end of the function
return