 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FIND LINKS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [link_data] = ...
    find_link (nsorgenti, sorgenti, nnode, noderaster, ...
    nrow, ncol, k_out, vettore_scarico, step, node)

% initialize time
ti0 = cputime;

%initialize the structure
link_data = repmat(struct('Km',0,'Kv',0,'IDm',0,'IDv',0,'L',0), nnode, 1);

% initialize the counter in the link matrix
klink = 0;

% initialize the array
matrix_aux_percorsi = zeros(nrow, ncol);
matrix_aux_percorsi(k_out) = 1;

% loop over each path
for jpath = 1:nsorgenti

% initialize the pointer
    pixel = sorgenti(jpath).k;

%% INITIALIZE THE COUNTERS OF THE CURRENT PATH

% initialize the lenght
    lunghezza = 0;

% update the counter
    klink = klink + 1;
    
% save the upstream pixel of the first link
    link_data(klink).Km = pixel;
    
%% LOOP OVER THE CURRENT PATH UNTIL THE OUTLET (IF FIRST) OR AN EXISTENT LINK
    while matrix_aux_percorsi(pixel) == 0
        
% update the auxiliar matrix
    	 matrix_aux_percorsi(pixel) = 1;
                                
% update the lenght
         lunghezza = lunghezza + step(pixel);             
                
% check if the current pixel is a node
         if noderaster(vettore_scarico(pixel)) == -1
                    
% update the link's structure information
            link_data(klink).Kv = vettore_scarico(pixel);
            link_data(klink).L = lunghezza;
            
            if matrix_aux_percorsi(vettore_scarico(pixel)) == 0
                klink = klink + 1;
                link_data(klink).Km = vettore_scarico(pixel);
                lunghezza = 0;
            end
            
         end
                
         pixel = vettore_scarico(pixel);

% end of the loop over each path       
    end

% end of the loop over paths
end

% extract k-field and ID-field from node structure
k = cat(1,node.k);
ID = cat(1,node.ID);

% assign the unique ID to each link's node
for jn = 1:nnode
      link_data(jn).IDm = ID((link_data(jn).Km==k(:,1)));
      link_data(jn).IDv = ID((link_data(jn).Kv==k(:,1)));
end

% end time
te = cputime;
% link_data(end) = [];
fprintf('link       : %10.3f s \n', te-ti0);

% end of the function
return