%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FIND THE NEXT DOWNSTREAM PIXEL FOR EACH PIXEL
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [vettore_scarico, dist, notnan] = find_next_downstream(data_flow)

% initialize time
ti = cputime;

% find the sizes
[nrow, ncol] = size(data_flow);

% initialize array
vettore_scarico = zeros(nrow*ncol,1);
dist = zeros(nrow*ncol,1);

% initialzie pointer
k = 0;

% loop over the flow matrix
for jc = 1:ncol
    for jr = 1:nrow
        
% update the pointer
        k = k + 1;
        
% set the downstream node of the current node, i.e. the node in which the
% current one drains the flow.
% es. the node 34 drains in the node 65, so vettore_scarico(34) = 65
        [~,~,knew,step]=D8_FLD(jr,jc,data_flow);
        vettore_scarico(k) = knew;
        dist(k) = step;
%        fprintf('%u %u %u %u \n', jr, jc, k, knew);
    end
end

% count the not-nan pixels
notnan = sum(sum(~isnan(vettore_scarico),2));

% initialize time
te = cputime;
fprintf('downstream : %10.3f s \n', te-ti);

% end of the function
return