% -------------------------------------------------------------------------
% 1. INPUT_FILEs (FLD and FLA)
% This code defines FLD and FLA matrix extracted from GRASS GIS.
% CODIFICATION: Flow Direction from GRASS to ArcGIS
% 
% 1 -1 = 128
% 2 -2 = 64
% 3 -3 = 32
% 4 -4 = 16
% 5 -5 = 8
% 6 -6 = 4
% 7 -7 = 2
% 8 -8 = 1
% 0 = 255
%--------------------------------------------------------------------------
% 
% Authors: Silvia Garbin
% Creation: july 2016
% Last update: august 2016
% 
% -------------------------------------------------------------------------
clear variables
close all;
clc
tic

load('input\original_input\flowdir_3.mat');
i= find(map_data<0); 
map_data(i)= NaN(size(i));
FLD=map_data;

a= find(FLD==1 | FLD==-1);
b= find(FLD==2 | FLD==-2);
c= find(FLD==3 | FLD==-3);
d= find(FLD==4 | FLD==-4);
e= find(FLD==5 | FLD==-5);
f= find(FLD==6 | FLD==-6);
g= find(FLD==7 | FLD==-7);
h= find(FLD==8 | FLD==-8);

FLD(a)=128;
FLD(b)=64;
FLD(c)=32;
FLD(d)=16;
FLD(e)=8;
FLD(f)=4;
FLD(g)=2;
FLD(h)=1;

% FLD = 2.^(8-abs(FLD));

load('input\original_input\flowacc_3.mat');
% i= find(isnan(map_data));
% map_data(i)= zeros(size(i));
FLA_start=map_data;

% assign flow direction to the outlet
    [M,I] = max(FLA_start(:));
    FLD(I)=64;

% save data in a structure
    data=struct('FLD',FLD,'FLA_start', FLA_start);
    save('input\data','data');

    
toc







