%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% CREATE RASTER OF LINKS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% every link is identified by 'monte' node ID and takes the
% properties (pdf's params values) of the 'monte' node 
% 
function [raster_link] = link2raster(nrow, ncol, nnode, scarico, link)

% initialize the matrix
raster_link = NaN(nrow, ncol);

% initialize the auxiliar array

aux = 0;
    
% loop over the number of link
for jL = 1:nnode-1

    aux = scarico (link(jL).Km);
    
% if the considered node is the outlet
    if link(jL).Kv == 0
        break
    end
    
% create the raster of links
    raster_link(link(jL).Km) = link(jL).IDm;
    
% from the 'monte' node go ahead following vettore scarico until reaching
% another node
    while aux ~= link(jL).Kv
        
% update the raster of links
        raster_link(aux) = link(jL).IDm;
    
% update the auxiliar array
        aux = scarico(aux);
    end
    
    raster_link(aux) = link(jL).IDv;
end

% end of the function
return
