% ===================PLOTTING
function net_plot(raster,flag)
switch flag
    
%% TOTAL DOMAIN
case 1
figure1 = figure('units','normalized','outerposition',[0.01 0.01 0.98 0.98]);
imagesc (raster)
RGB = [0 0 153;
     0 0 255;
     0 255 255;
     255 242 0;
     255 0 0;
     153 0 0]/255; 
prova_4colori = create_my_colormap_ncolors(70, 6, RGB, [1 1 1]);
colormap(prova_4colori);
caxis([0, max(raster(:))])
colorbar;
set(gca,'XTick',[],'YTick',[],'FontSize', 15); %'fontname', 'times new roman');
% title({'Local Connectivity in DRY climate for \lambda_{P} = 0.1 d^{-1}','and h^* = 50 mm'},'FontSize', 15);
% 'fontname', 'times new roman');
%     axis square
%% ZOOM DOMAIN
    case 2
    
figure1 = figure('units','normalized','outerposition',[0.01 0.01 0.98 0.98]);
% set left limit
raster(raster==0) = nan;
xleft = find(sum(~isnan(raster),1) > 0, 1 ,'first');
xright = find(sum(~isnan(raster),1) > 0, 1 ,'last');
yup = find(sum(~isnan(raster),2) > 0, 1 ,'first');
ydown = find(sum(~isnan(raster),2) > 0, 1 ,'last');

xleft = max(floor(xleft/10)*10 - 10,1);
xright = min(ceil(xright/10)*10 + 10,size(raster,2));
yup = max(floor(yup/10)*10 - 10,1);
ydown = min(ceil(ydown/10)*10 + 10,size(raster,1));

raster(isnan(raster)) = 0;
raster1 = raster(yup:ydown,xleft:xright);

imagesc(raster1');
RGB = [0 0 153;
     0 0 255;
     0 255 255;
     255 242 0;
     255 0 0;
     153 0 0]/255; 
 
prova_4colori = create_my_colormap_ncolors(1, 1, RGB, [1 1 1]);
colormap(prova_4colori);

caxis([0, max(raster(:))])
% colorbar;

set(gca,'XTick',[],'YTick',[],'FontSize', 15); %'fontname', 'times new roman');
% set(gca,'XTick','YTick','FontSize', 15); %'fontname', 'times new roman');

    otherwise
end


return