%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FIND PATH OF NODES IN WHICH THERE IS THE MAX NUMBER OF NODES
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [path_head, max_knode] = path4heads (nsorgenti, sorgenti, noderaster, ...
    k_out, vettore_scarico)

% initialize time
ti0 = cputime;

% initialize the structure
path_head = repmat(struct('nnode',0,'headpath',0),nsorgenti,1);

% initialize the maximum number of nodes in a path
max_knode = 0;

% loop for each path
for jpath = 1:nsorgenti
    
% initialize the path vector
    path = 0;
    
% initialize the counter in each path
    knode = 1;
    
% initialize the pointer
    pixel = sorgenti(jpath).k;
    
%% START THE COUNTING 

% save the node path
    path(knode) = pixel;    

% LOOP OVER THE CORRENT PATH
    while pixel ~= k_out

% update the pixel
        pixel = vettore_scarico(pixel);

% check if the current pixel is a node
        if noderaster(pixel) == -1
            
% update the counter of the node
            knode = knode +1; 
        
% save the node path
        path(knode) = pixel;    
        
        end      
% end of the loop over each path        
    end
       
    path_head(jpath).nnode = knode;
    path_head(jpath).headpath = path;
    
    max_knode = max(max_knode, knode);
    
    clear path
    
end

% end time
te = cputime;
% link_data(end) = [];
fprintf('headpath       : %10.3f s \n', te-ti0);

% end of the function
return
