% This code plots FIvsAREA and HvsArea and decreasing pattern

clear all; close all;

% load temporary files
load ('temp_01.mat');
load ('temp_05.mat');
load ('temp_1.mat');

% create a structure of temporary files
temp.temp01 = temp_01;
temp.temp05 = temp_05;
temp.temp1 = temp_1;

clearvars -except temp

% save temporary files in a unique file
save ('temp')

% TEMP 01
% sort nodes with respect to Area 
for jk = 1:length(temp.temp01)-1
    for jk1 = jk+1:length(temp.temp01)
        if temp.temp01(jk1).Area < temp.temp01(jk).Area
            aux = temp.temp01(jk);
            temp.temp01(jk) = temp.temp01(jk1);
            temp.temp01(jk1) = aux;
        end
    end
end

area = [temp.temp01.Area];
fi_01 = [temp.temp01.fi]/max([temp.temp01.fi]);
fi01 = [temp.temp01.fi];
hmedia_01 = [temp.temp01.h_media];
HS_01 = [temp.temp01.meanHS];
Clocal_01 = [temp.temp01.cnt];

% TEMP 05
% sort nodes with respect to Area 
for jk = 1:length(temp.temp05)-1
    for jk1 = jk+1:length(temp.temp05)
        if temp.temp05(jk1).Area < temp.temp05(jk).Area
            aux = temp.temp05(jk);
            temp.temp05(jk) = temp.temp05(jk1);
            temp.temp05(jk1) = aux;
        end
    end
end
fi_05 = [temp.temp05.fi]/max([temp.temp05.fi]);
fi05 = [temp.temp05.fi];
hmedia_05 = [temp.temp05.h_media];
HS_05 = [temp.temp05.meanHS];
Clocal_05 = [temp.temp05.cnt];

% TEMP 1
% sort nodes with respect to Area 
for jk = 1:length(temp.temp1)-1
    for jk1 = jk+1:length(temp.temp1)
        if temp.temp1(jk1).Area < temp.temp1(jk).Area
            aux = temp.temp1(jk);
            temp.temp1(jk) = temp.temp1(jk1);
            temp.temp1(jk1) = aux;
        end
    end
end
fi_1 = [temp.temp1.fi]/max([temp.temp1.fi]);
fi1 = [temp.temp1.fi];
hmedia_1 = [temp.temp1.h_media];
HS_1 = [temp.temp1.meanHS];
Clocal_1 = [temp.temp1.cnt];

%% PLOT FI/FImax vs Area
if(1)
    figure1 = figure('units','normalized','outerposition',[0.01 0.01 0.98 0.98]);
    set(figure1,'WindowStyle','docked')
    plot(area,fi_01,'.','MarkerSize',20,'LineWidth',1.5);
    hold on

    plot(area,fi_05,'.','MarkerSize',20,'LineWidth',1.5);
    hold on 

    plot(area,fi_1,'.','MarkerSize',20,'LineWidth',1.5);

    ylabel('\phi / \phi_{max}','FontSize',17)
    xlabel('A, Drainage area [Km^{2}]','FontSize',17)
    title('Dry climate','FontSize',17)
    set(gca,'FontSize', 15, 'LineWidth',.5); %'fontname', 'times new roman')
%     grid on
%     set(gca,'gridlinestyle','--')

    LEG = legend('\lambda_{P} = 0.1 d^{-1}','\lambda_{P} = 0.5 d^{-1}',...
        '\lambda_{P} = 1 d^{-1}');
    set(LEG,'FontSize',14)
end
%% PLOT FI vs Area
if(0)
    figure1 = figure('units','normalized','outerposition',[0.01 0.01 0.98 0.98]);
    set(figure1,'WindowStyle','docked')
    plot(area,fi01,'.','MarkerSize',20,'LineWidth',1.5);
    hold on

    plot(area,fi05,'.','MarkerSize',20,'LineWidth',1.5);
    hold on 

    plot(area,fi1,'.','MarkerSize',20,'LineWidth',1.5);

    ylabel('\phi','FontSize',17)
    xlabel('A, Drainage area [Km^{2}]','FontSize',17)
    title('Intermediate climate','FontSize',17)
    set(gca,'FontSize', 15, 'LineWidth',.5); %'fontname', 'times new roman')
%     grid on
%     set(gca,'gridlinestyle','--')

    LEG = legend('\lambda_{P} = 0.1 d^{-1}','\lambda_{P} = 0.5 d^{-1}',...
        '\lambda_{P} = 1 d^{-1}');
    set(LEG,'FontSize',14)
end
%% PLOT <h> vs Area
if(1)
    figure1 = figure('units','normalized','outerposition',[0.01 0.01 0.98 0.98]);
    set(figure1,'WindowStyle','docked')
    plot(area,hmedia_01,'.','MarkerSize',20,'LineWidth',1.5);
    hold on

    plot(area,hmedia_05,'.','MarkerSize',20,'LineWidth',1.5);
    hold on 

    plot(area,hmedia_1,'.','MarkerSize',20,'LineWidth',1.5);

    ylabel('Mean water depth [mm]','FontSize',17)
    xlabel('A, Drainage area [Km^{2}]','FontSize',17)
    title('Dry climate','FontSize',17)
    set(gca,'FontSize', 15, 'LineWidth',.5); %'fontname', 'times new roman')
%     grid on
%     set(gca,'gridlinestyle','--')

    LEG = legend('\lambda_{P} = 0.1 d^{-1}','\lambda_{P} = 0.5 d^{-1}',...
        '\lambda_{P} = 1 d^{-1}');
    set(LEG,'FontSize',14, 'Location','northwest')
end


%% PLOT Clocal vs Area
if(1)
    figure1 = figure('units','normalized','outerposition',[0.01 0.01 0.98 0.98]);
    set(figure1,'WindowStyle','docked')
    plot(area,Clocal_01,'.','MarkerSize',20,'LineWidth',1.5);
    hold on

    plot(area,Clocal_05,'.','MarkerSize',20,'LineWidth',1.5);
    hold on 

    plot(area,Clocal_1,'.','MarkerSize',20,'LineWidth',1.5);

    ylabel('Clocal','FontSize',17)
    xlabel('A, Drainage area [Km^{2}]','FontSize',17)
    title('Dry climate','FontSize',17)
    set(gca,'FontSize', 15, 'LineWidth',.5); %'fontname', 'times new roman')
%     grid on
%     set(gca,'gridlinestyle','--')

    LEG = legend('\lambda_{P} = 0.1 d^{-1}','\lambda_{P} = 0.5 d^{-1}',...
        '\lambda_{P} = 1 d^{-1}');
    set(LEG,'FontSize',14, 'Location','northwest')
end


%% PLOT HS vs Area
if(1)
    figure1 = figure('units','normalized','outerposition',[0.01 0.01 0.98 0.98]);
    set(figure1,'WindowStyle','docked')
    plot(area,HS_01,'.','MarkerSize',20,'LineWidth',1.5);
    hold on

    plot(area,HS_05,'.','MarkerSize',20,'LineWidth',1.5);
    hold on 

    plot(area,HS_1,'.','MarkerSize',20,'LineWidth',1.5);

    ylabel('<HS>','FontSize',17)
    xlabel('A, Drainage area [Km^{2}]','FontSize',17)
    title('Dry climate','FontSize',17)
    set(gca,'FontSize', 15, 'LineWidth',.5); %'fontname', 'times new roman')
%     grid on
%     set(gca,'gridlinestyle','--')

    LEG = legend('\lambda_{P} = 0.1 d^{-1}','\lambda_{P} = 0.5 d^{-1}',...
        '\lambda_{P} = 1 d^{-1}');
    set(LEG,'FontSize',14,'Location','bestoutside')
end
%% PLOT LINEAR REGRESSION FI/FImax vs. A
if (0)
[m01pl, q01pl] = linear_regression_fitting(length(area),log(area),log(fi_01));
fi01modelPL = m01pl*log(area)+q01pl;
RsquarePL = r_square(log(fi_01), fi01modelPL);

[m01exp, q01exp] = linear_regression_fitting(length(area),(area),log(fi_01));
fi01modelEXP = m01exp*(area)+q01exp;
RsquareEXP = r_square(log(fi_01), fi01modelEXP);


figure3 = figure('units','normalized','outerposition',[0.01 0.01 0.98 0.98]);
set(figure3,'WindowStyle','docked')
subplot(1,2,1)
plot(log(area),log(fi_01),'o','MarkerSize',8,'LineWidth',2);
hold on
plot (log(area),fi01modelPL,'LineWidth',1.5)
% text(0.30*max(log(area)), 0.6*min(log(fi_01)),['   R^2 = ' num2str(RsquarePL) ''],'FontSize', 15);
set(gca,'FontSize', 15, 'LineWidth',.5); %'fontname', 'times new roman')
title('Power law fitting (\lambda_P = 0.1 d^{-1})')
xlabel('Area','FontSize',17)
ylabel('\phi/\phi_{max}','FontSize',17)
% legend('Data','Power law Fit','FontSize',17)
subplot(1,2,2)
plot((area),log(fi_01),'o','MarkerSize',8,'LineWidth',2);
hold on
plot ((area),fi01modelEXP,'LineWidth',1.5)
text(0.20*max((area)), 0.7*min(log(fi_01)),['   R^2 = ' num2str(RsquareEXP) ''],'FontSize', 15);
% text(0.5*max((area)), 0.4*min(log(fi_01)),['   y = exp^{' num2str(1/100*floor(100*m01exp)) 'x} '],'FontSize', 20);
set(gca,'FontSize', 15, 'LineWidth',.5); %'fontname', 'times new roman')
title('Exponential fitting (\lambda_P = 0.1 d^{-1})')
xlabel('Area','FontSize',17)
ylabel('\phi/\phi_{max}','FontSize',17)
% legend('Data','Exponential Fit','FontSize',17)

%%
% [m03pl, q03pl] = linear_regression_fitting(length(area),log(area),log(fi_03));
% fi03modelPL = m03pl*log(area)+q03pl;
% RsquarePL = r_square(log(fi_03), fi03modelPL);
% 
% [m03exp, q03exp] = linear_regression_fitting(length(area),(area),log(fi_03));
% fi03modelEXP = m03exp*(area)+q03exp;
% RsquareEXP = r_square(log(fi_03), fi03modelEXP);
%  
% figure4 = figure('units','normalized','outerposition',[0.01 0.01 0.98 0.98]);
% set(figure4,'WindowStyle','docked')
% subplot(1,2,1)
% plot(log(area),log(fi_03),'o','MarkerSize',8,'LineWidth',2);
% hold on
% plot (log(area),fi03modelPL,'LineWidth',1.5)
% text(0.30*max(log(area)), 0.6*min(log(fi_03)),['   R^2 = ' num2str(RsquarePL) ''],'FontSize', 15);
% set(gca,'FontSize', 15, 'LineWidth',.5); %'fontname', 'times new roman')
% title('Power law fitting (\lambda_P = 0.3 d^{-1})')
% xlabel('Area','FontSize',17)
% ylabel('\phi/\phi_{max}','FontSize',17)
% % legend('Data','Power law Fit','FontSize',17) 
% subplot(1,2,2)
% plot((area),log(fi_03),'o','MarkerSize',8,'LineWidth',2);
% hold on
% plot ((area),fi03modelEXP,'LineWidth',1.5)
% text(0.20*max((area)), 0.7*min(log(fi_03)),['   R^2 = ' num2str(RsquareEXP) ''],'FontSize', 15);
% % text(0.5*max((area)), 0.4*min(log(fi_01)),['   y = exp^{' num2str(1/100*floor(100*m01exp)) 'x} '],'FontSize', 20);
% set(gca,'FontSize', 15, 'LineWidth',.5); %'fontname', 'times new roman')
% title('Exponential fitting (\lambda_P = 0.3 d^{-1})')
% xlabel('Area','FontSize',17)
% ylabel('\phi/\phi_{max}','FontSize',17)
% % legend('Data','Exponential Fit','FontSize',17)
%%
[m05pl, q05pl] = linear_regression_fitting(length(area),log(area),log(fi_05));
fi05modelPL = m05pl*log(area)+q05pl;
RsquarePL_05 = r_square(log(fi_05), fi05modelPL);

[m05exp, q05exp] = linear_regression_fitting(length(area),(area),log(fi_05));
fi05modelEXP = m05exp*(area)+q05exp;
RsquareEXP_05 = r_square(log(fi_05), fi05modelEXP);

figure5 = figure('units','normalized','outerposition',[0.01 0.01 0.98 0.98]);
set(figure5,'WindowStyle','docked')
subplot(1,2,1)
plot(log(area),log(fi_05),'o','MarkerSize',8,'LineWidth',2);
hold on
plot (log(area),fi05modelPL,'LineWidth',1.5)
text(0.30*max(log(area)), 0.6*min(log(fi_05)),['   R^2 = ' num2str(RsquarePL_05) ''],'FontSize', 15);
set(gca,'FontSize', 15, 'LineWidth',.5); %'fontname', 'times new roman')
title('Power law fitting (\lambda_P = 0.5 d^{-1})')
xlabel('Area','FontSize',17)
ylabel('\phi/\phi_{max}','FontSize',17)
% legend('Data','Power law Fit','FontSize',17)
subplot(1,2,2)
plot((area),log(fi_05),'o','MarkerSize',8,'LineWidth',2);
hold on
plot ((area),fi05modelEXP,'LineWidth',1.5)
text(0.20*max((area)), 0.8*min(log(fi_05)),['   R^2 = ' num2str(RsquareEXP_05) ''],'FontSize', 15);
set(gca,'FontSize', 15, 'LineWidth',.5); %'fontname', 'times new roman')
title('Exponential fitting (\lambda_P = 0.5 d^{-1})')
xlabel('Area','FontSize',17)
ylabel('\phi/\phi_{max}','FontSize',17)
% legend('Data','Exponential Fit','FontSize',17)
%%
% [m07pl, q07pl] = linear_regression_fitting(length(area),log(area),log(fi_07));
% fi07modelPL = m07pl*log(area)+q07pl;
% RsquarePL_07 = r_square(log(fi_07), fi07modelPL);
% 
% [m07exp, q07exp] = linear_regression_fitting(length(area),(area),log(fi_07));
% fi07modelEXP = m07exp*(area)+q07exp;
% RsquareEXP_07 = r_square(log(fi_07), fi07modelEXP);
% 
% figure6 = figure('units','normalized','outerposition',[0.01 0.01 0.98 0.98]);
% set(figure6,'WindowStyle','docked')
% subplot(1,2,1)
% plot(log(area),log(fi_07),'o','MarkerSize',8,'LineWidth',2);
% hold on
% plot (log(area),fi07modelPL,'LineWidth',1.5)
% text(0.30*max(log(area)), 0.6*min(log(fi_07)),['   R^2 = ' num2str(RsquarePL_07) ''],'FontSize', 15);
% set(gca,'FontSize', 15, 'LineWidth',.5); %'fontname', 'times new roman')
% title('Power law fitting (\lambda_P = 0.7 d^{-1})')
% xlabel('Area','FontSize',17)
% ylabel('\phi/\phi_{max}','FontSize',17)
% % legend('Data','Power law Fit','FontSize',17)
% subplot(1,2,2)
% plot((area),log(fi_07),'o','MarkerSize',8,'LineWidth',2);
% hold on
% plot ((area),fi07modelEXP,'LineWidth',1.5)
% text(0.20*max((area)), 0.8*min(log(fi_07)),['   R^2 = ' num2str(RsquareEXP_07) ''],'FontSize', 15);
% set(gca,'FontSize', 15, 'LineWidth',.5); %'fontname', 'times new roman')
% title('Exponential fitting (\lambda_P = 0.7 d^{-1})')
% xlabel('Area','FontSize',17)
% ylabel('\phi/\phi_{max}','FontSize',17)
% % legend('Data','Exponential Fit','FontSize',17)
%%
% [m09pl, q09pl] = linear_regression_fitting(length(area),log(area),log(fi_09));
% fi09modelPL = m09pl*log(area)+q09pl;
% RsquarePL = r_square(log(fi_01), fi01modelPL);
% 
% [m09exp, q09exp] = linear_regression_fitting(length(area),(area),log(fi_09));
% fi09modelEXP = m09exp*(area)+q09exp;
% RsquareEXP = r_square(log(fi_09), fi09modelEXP);
% 
% figure7 = figure('units','normalized','outerposition',[0.01 0.01 0.98 0.98]);
% set(figure7,'WindowStyle','docked')
% subplot(1,2,1)
% plot(log(area),log(fi_09),'o','MarkerSize',8,'LineWidth',2);
% hold on
% plot (log(area),fi09modelPL,'LineWidth',1.5)
% text(0.30*max(log(area)), 0.6*min(log(fi_09)),['   R^2 = ' num2str(RsquarePL) ''],'FontSize', 15);
% set(gca,'FontSize', 15, 'LineWidth',.5); %'fontname', 'times new roman')
% title('Power law fitting (\lambda_P = 0.9 d^{-1})')
% xlabel('Area','FontSize',17)
% ylabel('\phi/\phi_{max}','FontSize',17)
% % legend('Data','Power law Fit','FontSize',17)
% subplot(1,2,2)
% plot((area),log(fi_09),'o','MarkerSize',8,'LineWidth',2);
% hold on
% plot ((area),fi09modelEXP,'LineWidth',1.5)
% text(0.20*max((area)), 0.7*min(log(fi_09)),['   R^2 = ' num2str(RsquareEXP) ''],'FontSize', 15);
% % text(0.5*max((area)), 0.4*min(log(fi_01)),['   y = exp^{' num2str(1/100*floor(100*m01exp)) 'x} '],'FontSize', 20);
% set(gca,'FontSize', 15, 'LineWidth',.5); %'fontname', 'times new roman')
% title('Exponential fitting (\lambda_P = 0.9 d^{-1})')
% xlabel('Area','FontSize',17)
% ylabel('\phi/\phi_{max}','FontSize',17)
% % legend('Data','Exponential Fit','FontSize',17)
%%
[m1pl, q1pl] = linear_regression_fitting(length(area),log(area),log(fi_1));
fi1modelPL = m1pl*log(area)+q1pl;
RsquarePL_1 = r_square(log(fi_1), fi1modelPL);

[m1exp, q1exp] = linear_regression_fitting(length(area),(area),log(fi_1));
fi1modelEXP = m1exp*(area)+q1exp;
RsquareEXP_1 = r_square(log(fi_1), fi1modelEXP);

figure8 = figure('units','normalized','outerposition',[0.01 0.01 0.98 0.98]);
set(figure8,'WindowStyle','docked')
subplot(1,2,1)
plot(log(area),log(fi_1),'o','MarkerSize',6,'LineWidth',2);
hold on
plot (log(area),fi1modelPL,'LineWidth',1.5)
% text(0.50*max(log(area)), 0.5*min(log(fi_1)),['   R^2 = ' num2str(RsquarePL_1) ''],'FontSize', 15);
set(gca,'FontSize', 15, 'LineWidth',.5); %'fontname', 'times new roman')
title('Power law fitting (\lambda_P = 1 d^{-1})')
xlabel('log(A)','FontSize',17)
ylabel('log(\phi/\phi_{max})','FontSize',17)
% LEG = legend('Data','Power law Fit');
%     set(LEG,'FontSize',17, 'Location','northwest')
subplot(1,2,2)
plot((area),log(fi_1),'o','MarkerSize',8,'LineWidth',2);
hold on
plot ((area),fi1modelEXP,'LineWidth',1.5)
% text(0.30*max((area)), 0.5*min(log(fi_1)),['   R^2 = ' num2str(RsquareEXP_1) ''],'FontSize', 15);
set(gca,'FontSize', 15, 'LineWidth',.5); %'fontname', 'times new roman')
title('Exponential fitting (\lambda_P = 1 d^{-1})')
xlabel('Area','FontSize',17)
ylabel('\phi/\phi_{max}','FontSize',17)
% legend('Data','Exponential Fit','FontSize',17)

end
%%

