 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PLOTS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function plotting(raster)

    figure1 = figure('units','normalized','outerposition',[0.01 0.01 0.98 0.98]);
    set(figure1,'WindowStyle','docked')

    % set left limit
    raster(raster==0) = nan;
    xleft = find(sum(~isnan(raster),1) > 0, 1 ,'first');
    xright = find(sum(~isnan(raster),1) > 0, 1 ,'last');
    yup = find(sum(~isnan(raster),2) > 0, 1 ,'first');
    ydown = find(sum(~isnan(raster),2) > 0, 1 ,'last');

    xleft = max(floor(xleft/10)*10 - 10,1);
    xright = min(ceil(xright/10)*10 + 10,size(raster,2));
    yup = max(floor(yup/10)*10 - 10,1);
    ydown = min(ceil(ydown/10)*10 + 10,size(raster,1));

    raster(isnan(raster)) = 0;
    raster1 = raster(yup:ydown,xleft:xright);

    imagesc(raster1);
   
    RGB = [153   0   0;% venice red
           255   0   0;
           255 242   0;
             0 255 255; %light green
             0   0 255;
             0   0 153]/255; %prussian blue   

    colori = create_my_colormap_ncolors(70, 6, RGB, [1 1 1]);

    colormap(colori);

    caxis([0, max(raster(:))])
    colorbar;

    set(gca,'XTick',[],'YTick',[],'FontSize', 25); %'fontname', 'times new roman');
%     title('OUTLET CONNECTIVITY IN DRY CLIMATES','FontSize', 25); % 'fontname', 'times new roman');

% end of the function
return

