%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Create daily rainfall raster
% 
% Author: Silvia Garbin
% Creation: february 2017
% Last update: march 2017
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [rain] = rain_raster(center, nt, nrow, ncol)

% initialize time
ti0 = cputime;

% initialize the matrix
rain = zeros(nrow,ncol);
    
% loop over each center
for jc = 1:nt
    
% % check mass conservation
%     Vteorico = center(jc,3)^2 * pi * center(jc,4);
%     Veffettivo = 0;
        
% loop over the horizontal axes
	for jq = (center(jc,2)-center(jc,3)) : (center(jc,2)+center(jc,3))
        if jq ~= 0

            if mod(jq,ncol)~=0
                jq_finale = mod(jq,ncol);
                if jq<0
                    jq_finale = jq_finale + 1;
                end
            else
                if jq>0
                    jq_finale = ncol;
                else
                    jq_finale = center(jc,2);
                end
            end
                           
% find the max distance from current position to the horizontal axes
            id = round(sqrt(center(jc,3)^2-(jq-center(jc,2))^2));
        
% loop over the vertical axes
            for iq = (center(jc,1)-id) : (center(jc,1)+id)
                if iq ~= 0
                    if mod(iq,nrow)~=0
                        iq_finale = mod(iq,nrow);
                        if iq<0
                            iq_finale = iq_finale + 1;
                        end
                    else
                        if iq>0
                            iq_finale = nrow;
                        elseif iq<0
                            iq_finale = 1;
                        end
                    end

                    rain(iq_finale,jq_finale) = rain(iq_finale,jq_finale) + center(jc,4);
                
%                     Veffettivo = Veffettivo + center(jc,4);
                end
       
% end of vertical loop
            end
        
% end of horizontal loop
        end
        
    end
        
% end of each center loop
end

% end time
te = cputime;
% fprintf('rain_raster_bis  : %10.3f s \n', te-ti0);

% fprintf('Vteorico = %10.1f    Veffettivo = %10.1f    Residual relative rain volume = %10.1f \n', ...
%     Vteorico, Veffettivo, (Vteorico - Veffettivo)/Vteorico);
    
% end of the function
return

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% % case1: all in
%             if (center(jc,1)-center(jc,3)) >= 1 && (center(jc,1)+center(jc,3)) <= nrow
%                 iq_finale = iq;
%                 
% % case2: go out on the top    
% % one time
%         elseif iq < 1 && iq >= -nrow
%             iq_finale = nrow - abs(iq);
% % more times
%         elseif iq < -nrow
%             iq_finale = nrow - abs(ceil(abs(ic/nrow))*nrow - abs(iq));
%                       
% % case3: go out on the bottom    
% % one time
%         elseif iq > nrow && iq <= 2*nrow
%             iq_finale = abs(nrow-iq);
% % more times
%         elseif iq > 2*nrow
%             iq_finale = abs(floor(iq/nrow)*nrow-iq);                
% 
% % case4: go out somewhere but the current iq is inside the domain
%             else
%                 iq_finale = iq;
%             end